import sys
from PyQt5.QtWidgets import QApplication, QMainWindow, QPushButton, QLineEdit, QVBoxLayout, QWidget
from PyQt5.QtGui import QColor

class MiCalculadora(QMainWindow):
    def __init__(self):
        super().__init__()
        self.setWindowTitle("Calculadora")
        self.setGeometry(100, 100, 300, 400)

        # Crear un campo de texto
        self.entry = QLineEdit(self)
        self.entry.setGeometry(20, 20, 260, 40)

        # Crear los botones numéricos
        self.create_numeric_buttons()

        # Crear los botones de operaciones
        self.create_operation_buttons()

        # Botón de igual
        self.equal_button = QPushButton("=", self)
        self.equal_button.setGeometry(180, 340, 100, 40)
        self.equal_button.setStyleSheet("background-color: #00aaff; color: white;")
        self.equal_button.clicked.connect(self.calculate_result)

        # Botón de borrar
        self.clear_button = QPushButton("C", self)
        self.clear_button.setGeometry(20, 340, 40, 40)
        self.clear_button.setStyleSheet("background-color: #ff5555; color: white;")
        self.clear_button.clicked.connect(self.clear_entry)

        # Variable para almacenar el resultado
        self.result = 0

    def create_numeric_buttons(self):
        # Crear los botones numéricos del 0 al 9
        x, y = 20, 100
        for i in range(10):
            button = QPushButton(str(i), self)
            button.setGeometry(x, y, 60, 40)
            button.setStyleSheet("background-color: #555555; color: white; border-radius: 50%;")
            button.clicked.connect(lambda _, num=i: self.append_text(str(num)))
            x += 80
            if i % 3 == 2:
                x = 20
                y += 60

    def create_operation_buttons(self):
        # Crear los botones de operaciones
        operations = ['+', '-', '*', '/']
        x, y = 180, 100
        for op in operations:
            button = QPushButton(op, self)
            button.setGeometry(x, y, 60, 40)
            button.setStyleSheet("background-color: #009933; color: white; border-radius: 50%;")
            button.clicked.connect(lambda _, operator=op: self.append_text(operator))
            y += 60

    def append_text(self, text):
        self.entry.setText(self.entry.text() + text)

    def calculate_result(self):
        try:
            self.result = eval(self.entry.text())
            self.entry.setText(str(self.result))
        except Exception as e:
            self.entry.setText("Error")

    def clear_entry(self):
        self.entry.clear()

if __name__ == "__main__":
    app = QApplication(sys.argv)
    calculadora = MiCalculadora()
    calculadora.show()
    sys.exit(app.exec_())
